> Calendly developer docs. For page Markdown, append .md to any URL.
> Index: https://developer.calendly.com/llms.txt
> API catalog: https://developer.calendly.com/.well-known/api-catalog
> OpenAPI: https://developer.calendly.com/openapi/calendly-api.yaml
> OAuth authorization server: https://calendly.com/.well-known/oauth-authorization-server
> MCP protected resource: https://mcp.calendly.com/.well-known/oauth-protected-resource
> Scheduling MCP endpoint: https://mcp.calendly.com
> Docs search MCP: https://developer.calendly.com/_mcp/server

# List Routing Form Submissions

GET https://api.calendly.com/routing_form_submissions

Get a list of Routing Form Submissions for a specified Routing Form.

> `routing_forms:read`

Reference: https://developer.calendly.com/api-docs/calendly-api/routing-forms/list-routing-form-submissions

## Authentication

- `Authorization` header (bearer token, required) — OAuth 2.0
- `Authorization` header (bearer token, required) — Personal Access Token

## Request

### Query parameters

- `form` (string, required) — View routing form submissions associated with the routing form's URI.
- `count` (integer, optional, default: 20) — The number of rows to return
- `page_token` (string, optional) — The token to pass to get the next or previous portion of the collection
- `sort` (string, optional) — Order results by the specified field and direction. Accepts comma-separated list of \{field}:\{direction} values. Supported fields are: created\_at. Sort direction is specified as: asc, desc.

## Response

### 200

OK

- `collection` (list of RoutingFormSubmission, required)
- `pagination` (Pagination, required)

## Errors

### 400 Bad Request Error

Request is not valid

- `title` (enum, required)
  - Allowed values: `Internal Server Error`
- `message` (enum, required)
  - Allowed values: `The server encountered an unexpected condition that prevented it from fulfilling the request.`
- `details` (list of ErrorResponseDetailsItem, optional)

### 401 Unauthorized Error

Cannot authenticate caller

- `title` (enum, required)
  - Allowed values: `Internal Server Error`
- `message` (enum, required)
  - Allowed values: `The server encountered an unexpected condition that prevented it from fulfilling the request.`
- `details` (list of ErrorResponseDetailsItem, optional)

### 403 Forbidden Error

Permission denied or insufficient scope

- `List-routing-form-submissionsRequestForbiddenError`

### 404 Not Found Error

Requested resource not found

- `title` (enum, required)
  - Allowed values: `Internal Server Error`
- `message` (enum, required)
  - Allowed values: `The server encountered an unexpected condition that prevented it from fulfilling the request.`
- `details` (list of ErrorResponseDetailsItem, optional)

### 500 Internal Server Error

An error has occurred on the server

- `title` (enum, required)
  - Allowed values: `Internal Server Error`
- `message` (enum, required)
  - Allowed values: `The server encountered an unexpected condition that prevented it from fulfilling the request.`
- `details` (list of ErrorResponseDetailsItem, optional)

## Types

### RoutingFormSubmission

Information about a Routing Form Submission.

- `uri` (string, required) — Canonical reference (unique identifier) for the routing form submission.
- `routing_form` (string, required) — The URI of the routing form that's associated with the submission.
- `questions_and_answers` (list of SubmissionQuestionAndAnswer, required) — All Routing Form Submission questions with answers.
- `tracking` (SubmissionTracking, required) — The UTM and Salesforce tracking parameters associated with a Routing Form Submission.
- `submitter` (string, required, nullable) — The reference to the Invitee resource when routing form submission results in a scheduled meeting.
- `submitter_type` (enum, required, nullable) — Type of the respondent resource that submitted the form and scheduled a meeting.
  - Allowed values: `Invitee`
- `created_at` (string, required) — The moment the routing form was submitted.
- `updated_at` (string, required) — The moment when the routing form submission was last updated.
- `result` (SubmissionResult, optional) — The polymorphic base type for a Routing Form Submission result.

### Pagination

- `count` (integer, required) — The number of rows to return
- `next_page` (string, required, nullable) — URI to return the next page of an ordered list ("null" indicates no additional results are available)
- `previous_page` (string, required, nullable) — URI to return the previous page of an ordered list ("null" indicates no additional results are available)
- `next_page_token` (string, required, nullable) — Token to return the next page of an ordered list ("null" indicates no additional results are available)
- `previous_page_token` (string, required, nullable) — Token to return the previous page of an ordered list ("null" indicates no additional results are available)

### ErrorResponseDetailsItem

- `message` (string, required)
- `parameter` (string, optional)
- `code` (string, optional)

### ListRoutingFormSubmissionsRequestForbiddenError0

Error Object

- `title` (enum, required)
  - Allowed values: `Permission Denied`
- `message` (enum, required)
  - Allowed values: `You do not have permission to access this resource.`, `You do not have permission`
- `details` (list of ErrorResponseDetailsItem, optional)

### InsufficientScopeError

Caller does not have required oauth scopes

- `title` (enum, required)
  - Allowed values: `Insufficient scope`
- `message` (enum, required)
  - Allowed values: `This operation requires the scopes listed in the 'required_scopes' array.`
- `required_scopes` (list of string, required)

### SubmissionQuestionAndAnswer

All Routing Form Submission questions with answers.

- `question_uuid` (string, required, nullable) — Unique identifier for the routing form question.
- `question` (string, required) — Question name (in human-readable format).
- `answer` (string, optional, nullable) — Answer provided by the respondent when the form was submitted.

### SubmissionTracking

The UTM and Salesforce tracking parameters associated with a Routing Form Submission.

- `utm_campaign` (string, required, nullable) — The UTM parameter used to track a campaign.
- `utm_source` (string, required, nullable) — The UTM parameter that identifies the source (platform where the traffic originates).
- `utm_medium` (string, required, nullable) — The UTM parameter that identifies the type of input (e.g. Cost Per Click (CPC), social media, affiliate or QR code).
- `utm_content` (string, required, nullable) — UTM content tracking parameter.
- `utm_term` (string, required, nullable) — The UTM parameter used to track keywords.
- `salesforce_uuid` (string, required, nullable) — The Salesforce record unique identifier.

### SubmissionResult

The polymorphic base type for a Routing Form Submission result.

### SubmissionEventTypeResult

Information about the event type Routing Form Submission result.

- `type` (enum, required) — Indicates that the routing form submission resulted in a redirect to an event type booking page.
  - Allowed values: `event_type`
- `value` (string, required) — A reference to the event type resource.

### SubmissionExternalUrlResult

Information about the external URL Routing Form Submission result.

- `type` (enum, required) — Indicates that the routing form submission resulted in a redirect to an external URL.
  - Allowed values: `external_url`
- `value` (string, required) — The external URL the respondent were redirected to.

### SubmissionCustomMessageResult

Information about the custom message Routing Form Submission result.

- `type` (enum, required) — Indicates if the routing form submission resulted in a custom "thank you" message.
  - Allowed values: `custom_message`
- `value` (SubmissionCustomMessageResultValue, required) — Contains an object with custom message headline and body.

### SubmissionCustomMessageResultValue

Contains an object with custom message headline and body.

- `headline` (string, required) — Headline displayed when answers don't match any routes.
- `body` (string, required) — Body text displayed when answers don't match any routes.

## Examples

**Response**

```json
{
  "collection": [
    {
      "uri": "https://api.calendly.com/routing_form_submissions/AAAAAAAAAAAAAAAA",
      "routing_form": "https://api.calendly.com/routing_forms/AAAAAAAAAAAAAAAA",
      "questions_and_answers": [
        {
          "question_uuid": "dddddddd-dddd-dddd-dddd-dddddddddddd",
          "question": "What is your industry?",
          "answer": "IT & Software"
        }
      ],
      "tracking": {
        "utm_campaign": null,
        "utm_source": null,
        "utm_medium": null,
        "utm_content": null,
        "utm_term": null,
        "salesforce_uuid": null
      },
      "submitter": "https://calendly.com/scheduled_events/AAAAAAAAAAAAAAAA/invitees/AAAAAAAAAAAAAAAA",
      "submitter_type": "Invitee",
      "created_at": "2022-05-15T03:04:05.678Z",
      "updated_at": "2022-05-15T06:05:04.321Z",
      "result": {
        "type": "event_type",
        "value": "https://api.calendly.com/event_types/AAAAAAAAAAAAAAAA"
      }
    }
  ],
  "pagination": {
    "count": 20,
    "next_page": "https://api.calendly.com/routing_form_submissions?count=1&page_token=d8T0LKQ1XsC2utmPlI7TFPpHX4SSfoGl",
    "previous_page": "https://api.calendly.com/routing_form_submissions?count=1&page_token=VJs2rfDYeY8ahZpq0QI1O114LJkNjd7H",
    "next_page_token": "d8T0LKQ1XsC2utmPlI7TFPpHX4SSfoGl",
    "previous_page_token": "VJs2rfDYeY8ahZpq0QI1O114LJkNjd7H"
  }
}
```

**SDK Code**

```python Routing Form Submissions
import requests

url = "https://api.calendly.com/routing_form_submissions"

querystring = {"form":"https://api.calendly.com/routing_forms/AAAAAAAAAAAAAAAA","sort":"created_at:asc"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Routing Form Submissions
const url = 'https://api.calendly.com/routing_form_submissions?form=https%3A%2F%2Fapi.calendly.com%2Frouting_forms%2FAAAAAAAAAAAAAAAA&sort=created_at%3Aasc';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Routing Form Submissions
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.calendly.com/routing_form_submissions?form=https%3A%2F%2Fapi.calendly.com%2Frouting_forms%2FAAAAAAAAAAAAAAAA&sort=created_at%3Aasc"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Routing Form Submissions
require 'uri'
require 'net/http'

url = URI("https://api.calendly.com/routing_form_submissions?form=https%3A%2F%2Fapi.calendly.com%2Frouting_forms%2FAAAAAAAAAAAAAAAA&sort=created_at%3Aasc")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Routing Form Submissions
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.calendly.com/routing_form_submissions?form=https%3A%2F%2Fapi.calendly.com%2Frouting_forms%2FAAAAAAAAAAAAAAAA&sort=created_at%3Aasc")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Routing Form Submissions
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.calendly.com/routing_form_submissions?form=https%3A%2F%2Fapi.calendly.com%2Frouting_forms%2FAAAAAAAAAAAAAAAA&sort=created_at%3Aasc', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Routing Form Submissions
using RestSharp;

var client = new RestClient("https://api.calendly.com/routing_form_submissions?form=https%3A%2F%2Fapi.calendly.com%2Frouting_forms%2FAAAAAAAAAAAAAAAA&sort=created_at%3Aasc");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Routing Form Submissions
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.calendly.com/routing_form_submissions?form=https%3A%2F%2Fapi.calendly.com%2Frouting_forms%2FAAAAAAAAAAAAAAAA&sort=created_at%3Aasc")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```